<script setup>
    import { reactive, watch, ref } from 'vue';

    const props = defineProps(['facture']);

    const facture = reactive({
        date: "",
        emetteur: "",
        prix: "",
        description: ""
    });

    if (props.facture) {
        watch(() => props.facture.date, () => {
            facture.date = props.facture.date
            facture.emetteur = props.facture.emetteur
            facture.prix = props.facture.prix
            facture.description = props.facture.description
        });
    }

    const validDate = ref(true);
    const validEmetteur = ref(true);
    const validPrix = ref(true);
    const validDescription = ref(true);

    const formIsValid = ref(false);

    const validateForm = () => {
        validDate.value = facture.date !== "";
        validEmetteur.value = facture.emetteur.trim() !== "";
        validPrix.value = facture.prix !== "";
        validDescription.value = facture.description.trim() !== "";

        formIsValid.value = validDate.value && validEmetteur.value && validPrix.value && validDescription.value;
    };

    watch(() => [facture.date, facture.emetteur, facture.prix, facture.description], () => {
        validateForm();
    });
</script>

<template>
    <div class="card">
        <div class="card-body">
            <form>
                <div class="mb-3">
                    <label for="date" class="form-label">Date</label>
                    <div v-if="!validDate" class="text-danger">La date est requise</div>
                    <input type="date" id="date" class="form-control" v-model="facture.date">
                </div>
                <div class="mb-3">
                    <label for="emetteur" class="form-label">Émetteur</label>
                    <div v-if="!validEmetteur" class="text-danger">L'émetteur est requis</div>
                    <input type="text" id="emetteur" class="form-control" v-model="facture.emetteur">
                </div>
                <div class="mb-3">
                    <label for="prix" class="form-label">Montant</label>
                    <div v-if="!validPrix" class="text-danger">Le montant est requis</div>
                    <input type="number" id="prix" class="form-control" v-model="facture.prix">
                </div>
                <div class="mb-3">
                    <label for="description" class="form-label">Description</label>
                    <div v-if="!validDescription" class="text-danger">La description est requise</div>
                    <textarea id="description" class="form-control" v-model="facture.description"></textarea>
                </div>
                <div class="d-flex justify-content-center">
                    <input type="button" class="btn btn-primary button" @click="$emit('envoie', facture)" value="Envoyer" :disabled="!formIsValid">
                </div>
            </form>
        </div>
    </div>
</template>

<style scoped>
    .card {
        width: 400px;
        margin: 0 auto;
        margin-top: 20px;
    }
</style>